% setup
addpath utility/ sh/ slepian/

%% Slepian functions: some general properties

L = 20;
Theta = [15,20,25,30];
num_fcts_plot = 10;

% Plot Slepian functions (note that this opens a new figure window for 
% every basis functions, that is in total (L+1)^2 windows)
% use only one cap for simplicity and execution time
% Plot the num_fcts plot *first* Slepian functions from the spectrum, that is
% the fcts which are optimally concentrated
plotFctsSlepianCap( L, Theta(end), num_fcts_plot, 'first');
% Plot the num_fcts plot *last* Slepian functions from the spectrum, that is
% the fcts which are least concentrated
plotFctsSlepianCap( L, Theta(end), num_fcts_plot, 'last');

% plot spectrum of spatio-spectral concentration problem
plotEvalsSlepianCap( L, Theta);

%% Experimental verification of effective dimension of light transport 
%  Compare SVD of empirical transport operators for spherical cap
%  and theoretical prediction

% Diffuse transport
L = 2;
Theta = [15,20,25,30];
experimentTransport( L, 'diffuse', Theta);

% Phong transport
L = 20;
Theta = [5,10,15,20];
experimentTransport( L, 'phong', Theta, 128);