function out=insert(in,derin,pos)
% out=INSERT(in,derin,pos)
% 
% INPUT:
%
% in       Data matrix
% derin    Additional elements
% pos      Replaces these positions in old matrix and rightshifts the rest
%
% EXAMPLE:
%
% insert([1 2 3],[11 12],[2 3])
% insert([1 2 3],[11 13],[2 2]) 
%
% Last modified by fjsimons-at-alum.mit.edu, 29.05.2006

if isempty(pos)
  out=in;
  return
end

in=in(:)';
derin=derin(:)';
pos=pos(:)';

% If there is one unique last position
if pos(end)==(length(in)+1) & pos(end-1)~=(length(in)+1)
  lest=derin(end);
  derin=derin(1:end-1);
  pos=pos(1:end-1);
  flag=1;
elseif pos(end)==(length(in)+1) & pos(end-1)==(length(in)+1)
  error('Cannot add multiple elements past the range')
else
  flag=[];
end

% Figure out the multiplicity of these position elements
[a,b]=degamini(pos);
slot=gamini(b,b)+1;

indices=ones(1,length(in));

% Need to provide the right number of new slots
indices(pos)=slot;
out=gamini(in,indices);
% A similar trick is also used in MAKENOD
out(pos+(1:length(pos))-1)=derin; 

if flag==1
  out=[out lest];
end
