function [A, dA] = areaSphericalCap( theta)
%
% [A,dA] = areaSphericalCap( theta)
% 
% Area of a spherical cap with max. latitude theta.
%
% @return A     area
% @return dA    length of the boundary of the cap
% @param theta  max. latitude of the cap (in radians)

 A = 2*pi*(1 - cos(theta));
 dA = 2*pi*sin(theta);
 
end